#include "FacErrors.h"

int gErrorLimit = 150;

Q_GLOBAL_STATIC(FacErrors, gsFacErrors)

FacErrors* FacErrors::instance()
{
   return gsFacErrors();
}

FacErrors::~FacErrors()
{
   clearErrorList();
}

void FacErrors::error(Error::eErrorType aType, QString aMessage, int aCode, bool aException)
{
   Error* lError = new Error(aType, aMessage, aCode);
   mErrors.append(lError);

   // remove errors beyond limit
   while(mErrors.size() > gErrorLimit)
   {
      Error* lError = mErrors.first();
      mErrors.removeFirst();
      delete lError;
   }

   emit newError(lError);

   if(aType == Error::eCritical)
      gMessage(aMessage, "", aMessage, Error::eCritical);
#ifdef DEBUG
   if(aType == Error::eWarning)
      gMessage(aMessage, "", aMessage, Error::eWarning);
#endif
   if(aException)
      throw Exception(aMessage, aCode);
}

QList<Error*> FacErrors::errors()
{
   return mErrors;
}

void FacErrors::clearErrorList()
{
   for(int i = 0; i < mErrors.size(); ++i)
      delete mErrors[i];
   mErrors.clear();
}
