#include <iostream>
#include "FacErrors.h"
#include "UserImp.h"

UserImp::UserImp(PortableServer::POA_var aPoa) : QObject(0), POA_TCzat::User()
    , mPoa(PortableServer::POA::_duplicate(aPoa))
{
    gInformation("UserImp::UserImp");
}

UserImp::~UserImp()
{
    gInformation("UserImp::~UserImp");
}

TCzat::eUserType UserImp::userType()
{
    return mUserType;
}

void UserImp::userType(::TCzat::eUserType _v)
{
    mUserType = _v;
}

::CORBA::WChar* UserImp::name()
{
    return ::CORBA::wstring_dup(mName.toStdWString().c_str());
}

void UserImp::name(const ::CORBA::WChar* _v)
{
    mName = QString::fromWCharArray(_v);
}

::CORBA::WChar* UserImp::password()
{
    return ::CORBA::wstring_dup(mPassword.toStdWString().c_str());
}

void UserImp::password(const ::CORBA::WChar* _v)
{
    mPassword = QString::fromWCharArray(_v);
}

void UserImp::showMessage(const ::CORBA::WChar* aFrom, const ::CORBA::WChar* aTo, const ::CORBA::WChar* aMessage)
{
    emit newMessage(QString::fromWCharArray(aFrom), QString::fromWCharArray(aTo), QString::fromWCharArray(aMessage));
}

void UserImp::sendMessage(const ::CORBA::WChar* aFrom, const ::CORBA::WChar* aTo, const ::CORBA::WChar* aMessage)
{
    //emit sendMessageToServer(aFrom, aTo, aMessage);
}

void UserImp::addUser(::TCzat::User_ptr aUser)
{
    emit sigAddUser(QString::fromWCharArray(aUser->name()));
}

void UserImp::delUser(::TCzat::User_ptr aUser)
{
    emit sigDelUser(QString::fromWCharArray(aUser->name()));
}

void UserImp::destroy()
{
    gInformation("UserImp::destroy() - begin");
    //TCzat::User_ptr lUserPtr = _this();
    //mRoomController->removeUser(lUserPtr);
    //mRoomController->destroy();
    //CORBA::release(mRoomController);
    mPoa->deactivate_object(mUserObjectID);
    gInformation("UserImp::destroy() - end");
}

