#include <QSettings>
#include "WinLogin.h"
#include "ui_WinLogin.h"

WinLogin::WinLogin(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::WinLogin)
{
    ui->setupUi(this);

    connect(ui->mLogin, &QPushButton::clicked, this, &WinLogin::login);
    connect(ui->mCancel, &QPushButton::clicked, this, &WinLogin::reject);

    // restore previously typed values
    QSettings lSettings("./tczat2-client.ini", QSettings::IniFormat);
    //QSettings lSettings(QSettings::IniFormat, QSettings::UserScope, gOrg, gApp);
    ui->mRoom->setText(lSettings.value("Room", "").toString());
    ui->mUserLogin->setText(lSettings.value("UserLogin", "").toString());
    ui->mPassword->setText(lSettings.value("Password", "").toString());
}

WinLogin::~WinLogin()
{
    // save typed values
    QSettings lSettings("./tczat2-client.ini", QSettings::IniFormat);
    //QSettings lSettings(QSettings::IniFormat, QSettings::UserScope, gOrg, gApp);
    lSettings.setValue("Room", ui->mRoom->text());
    lSettings.setValue("UserLogin", ui->mUserLogin->text());
    lSettings.setValue("Password", ui->mPassword->text());
    delete ui;
}

void WinLogin::login()
{
    mRoomName = ui->mRoom->text();
    mUserLogin = ui->mUserLogin->text();
    mPassword = ui->mPassword->text();
    accept();
}

