#include <iostream>
#include "FacRoomImp.h"
#include "RoomImp.h"
#include "FacErrors.h"

using namespace std;

FacRoomImp::FacRoomImp(PortableServer::POA_ptr aPoa)
    : mPoa(PortableServer::POA::_duplicate(aPoa))
{
    gInformation("FacRoomImp::FacRoomImp");
}

FacRoomImp::~FacRoomImp()
{
    gInformation("FacRoomImp::~FacRoomImp - begin");

    for(int i = 0; i < mRooms.size(); ++i)
        closeRoom(mRooms[i]);
    mRooms.clear();

    gInformation("FacRoomImp::~FacRoomImp - end");
}

TCzat::Room_ptr FacRoomImp::openRoom(const ::CORBA::WChar* aRoomName)
{
    TCzat::FacRoom_var lFacRoom = _this();
    RoomImp* lRoom = new RoomImp(mPoa, lFacRoom, QString::fromWCharArray(aRoomName));
    mPoa->activate_object(lRoom);
    TCzat::Room_ptr lRoomPtr = lRoom->_this();
    mRooms.append(TCzat::Room::_duplicate(lRoomPtr));
    return lRoomPtr;
}

TCzat::RoomSeq* FacRoomImp::openedRoomList()
{
    TCzat::RoomSeq_var lRoomSeq = new TCzat::RoomSeq();
    lRoomSeq->length(mRooms.size());
    for(int i = 0; i < mRooms.size(); ++i)
        lRoomSeq[i] = TCzat::Room::_duplicate(mRooms[i]);
    return lRoomSeq._retn();
}

void FacRoomImp::closeRoom(::TCzat::Room_ptr aRoom)
{
    for(int i = 0; i < mRooms.size();)
    {
        if(QString::fromWCharArray(mRooms[i]->name()) == QString::fromWCharArray(aRoom->name()))
        {
            PortableServer::ObjectId_var lId = mPoa->reference_to_id(mRooms[i]);
            mPoa->deactivate_object(lId);
            mRooms.removeAt(i);
        }
        else
            ++i;
    }
}
