#include <iostream>
#include "IteUserImp.h"
#include "RoomImp.h"
#include "../tczat-interfaces/tczat.hh"
#include "FacErrors.h"

using namespace std;

IteUserImp::IteUserImp(TCzat::Room_ptr aRoom, PortableServer::POA_ptr aPoa, QList<TCzat::User_var> &aUsers)
    : POA_TCzat::IteUser(), mRoom(aRoom), mPoa(aPoa), mUsers(aUsers)
{
    gInformation("IteUserImp::IteUserImp");
}

IteUserImp::~IteUserImp()
{
    gInformation("IteUserImp::~IteUserImp - begin");
    CORBA::release(mRoom);
    CORBA::release(mPoa);
    gInformation("IteUserImp::~IteUserImp - end");
}

TCzat::UserSeq* IteUserImp::nextN(::CORBA::Long aHowMany)
{
    TCzat::UserSeq_var lUserSeq = new TCzat::UserSeq(aHowMany);
    lUserSeq->length(aHowMany);
    for(int i = 0; i < mUsers.size(); ++i)
        lUserSeq[i] = TCzat::User::_duplicate(mUsers[i]);
    return lUserSeq._retn();
}

void IteUserImp::destroy()
{
    TCzat::IteUser_var lIteUser = _this();
    mRoom->removeIteUser(lIteUser);
    PortableServer::ObjectId_var lId = mPoa->servant_to_id(this);
    mPoa->deactivate_object(lId);
}
