#include <omniORB4/CORBA.h>
#include <omniORB4/Naming.hh>
#include <iostream>
#include "RoomImp.h"
#include "FacErrors.h"
#include "FacRoomImp.h"

using namespace std;

int main(int argc, char *argv[])
{
    CORBA::ORB_var lORB;
    PortableServer::POA_var lPoa;
    try
    {
        lORB = CORBA::ORB_init(argc, argv);
        CORBA::Object_var lPOAObj = lORB->resolve_initial_references("RootPOA");
        lPoa = PortableServer::POA::_narrow(lPOAObj);
        PortableServer::POAManager_var lPOAManager = lPoa->the_POAManager();
        lPOAManager->activate();
    }
    catch(...)
    {
        cerr << "Create and activate corba poa failed!" << endl;
        return EXIT_FAILURE;
    }

    FacRoomImp* lFacRoom(0);
    try
    {
        lFacRoom = new FacRoomImp(lPoa);
    }
//    RoomImp* lRoom(0);
//    try
//    {
//        lRoom = new RoomImp(lPoa, "Room 1");
//    }
    catch(...)
    {
        cerr << "Create and activate corba servant failed!" << endl;
        return EXIT_FAILURE;
    }

    CosNaming::NamingContext_var lNamingContext;
    try
    {
        CORBA::Object_var lNameServiceObj = lORB->resolve_initial_references("NameService");
        if(CORBA::is_nil(lNameServiceObj))
            throw Exception("lNameServiceObj is nil.");
        CosNaming::NamingContext_ptr lNamingContext = CosNaming::NamingContext::_narrow(lNameServiceObj);
        CosNaming::Name lName;
        lName.length(1);
        lName[0].id = CORBA::string_dup("FacRoom");
        lName[0].kind = CORBA::string_dup("Object");
        TCzat::FacRoom_var lFacRoomVar = lFacRoom->_this();
        lNamingContext->rebind(lName, lFacRoomVar);
    }
    catch(...)
    {
        cerr << "Corba naming servive create and activate failed!" << endl;
        return EXIT_FAILURE;
    }

    lORB->run();
    return EXIT_SUCCESS;
}
