#include <iostream>
#include <string>
#include "RoomControllerImp.h"
#include "../tczat-interfaces/tczat.hh"
#include "FacErrors.h"

using namespace std;

RoomControllerImp::RoomControllerImp(TCzat::Room_ptr aRoom, PortableServer::POA_ptr aPoa)
    : POA_TCzat::RoomController(), mRoom(TCzat::Room::_duplicate(aRoom)), mPoa(PortableServer::POA::_duplicate(aPoa))
{
    gInformation("RoomControllerImp::RoomControllerImp");
}

RoomControllerImp::~RoomControllerImp()
{
    gInformation("RoomControllerImp::~RoomControllerImp - begin");
    CORBA::release(mRoom);
    CORBA::release(mPoa);
    gInformation("RoomControllerImp::~RoomControllerImp - end");
}

void RoomControllerImp::message(const ::CORBA::WChar* aFrom, const ::CORBA::WChar* aTo, const ::CORBA::WChar* aMessage)
{
    mRoom->message(aFrom, aTo, aMessage);
}

void RoomControllerImp::removeUser(::TCzat::User_ptr aUser)
{
    mRoom->removeUser(aUser);
}

TCzat::IteUser_ptr RoomControllerImp::users()
{
    TCzat::IteUser_ptr lIteUserPtr = mRoom->users();
    return lIteUserPtr;
}


void RoomControllerImp::destroy()
{
    PortableServer::ObjectId_var lId = mPoa->servant_to_id(this);
    mPoa->deactivate_object(lId);
    //_remove_ref();  // this is needed due leaked reference from RoomImp::joinUser
}
